import pyPgSQL.PgSQL as dbapi

class atcmapper:
	def __init__(self, db='atcdict', user='drugref', pwd='', host='localhost', port='8123'):
		self._db = db
		self._user = user
		self._pwd = pwd
		self._host = host
		self._port = port
		self._db = dbapi.connect(database=self._db)
		
		
		
	def atc(self, term, as_resultset=0):
		term = term.upper().strip()
		codes = []
		cur = self._db.cursor()
		cur.execute("select codes as code_atc from atc.atc where description like %(term)s", {'term':term})
		results = cur.fetchall()
		if as_resultset:
			return results
		for result in results:
			codelist = result[0]
			if not codelist:
				continue
			for code in codelist:
				if code not in codes:
					codes.append(code)
		return codes
	
import drugrefapi_base	
		
class drugref_atcmapper(drugrefapi_base.drugrefapi):
	def __init__(self, host='localhost', port=8123, database='atcdict', user='drugref', pwd='drugref', backend='postgres'):
		drugrefapi_base.drugrefapi.__init__(self, host='localhost', port=8123, database='atcdict', user='drugref', pwd='postgres', backend='postgres')
		self._mapper = atcmapper(db=database, user=user, pwd=pwd, host=host, port=port)
		self._name = "Drugref ATC code mapper"
		self._version = "1.0"
		self._versiondate = "08.02.2005"
		self._funcs['findATC'] = self.findATC 
		self.addfunc('findATC', '_search_drug_name', ["code_atc"]) 
		
	def findATC(self, searchexpr):
		return self._mapper.atc(searchexpr, as_resultset=1)

		
import drugrefapi_plugin

class drugrefplugin(drugrefapi_plugin.drugrefplugin):
	def __init__(self):
		drugrefapi_plugin.drugrefplugin.__init__(self)
		self._plugin = drugref_atcmapper()
		self._provides = self._plugin.list_capabilities()
		self._name = self._plugin.get_name()
		self._version = self._plugin.get_version()
		
		
if __name__ == "__main__":
	import sys
	term = sys.argv[1]
	mapper = atcmapper()
	codes = mapper.atc(term)
	for code in codes:
		print code
	plugin = drugref_atcmapper()
	codes = plugin.find('code_atc', term)
	print "atc codes found for", term, ":"
	for code in codes:
		print code['code_atc']