#! /usr/bin/python
############################################################
# brief example on howto use the drugref xmlrpc server
# from the client side
# (c) by Dr Horst Herb, released under the GPL free software
# license, details see http://www.gnu.org
############################################################
import sys, string, xmlrpclib

try:
	url = sys.argv[1]
except:
	url = "http://localhost"
	
if url[0:7] != 'http://':
	url = "http://%s" % url 

try:
	port = int(sys.argv[2])
except:
	port = 8001

server_url = "%s:%d" % (url, port)

print "connecting to server %s ..." % server_url

server=xmlrpclib.ServerProxy(server_url)

print"\n=========================================================="
print '       Drugref.org interactive browser V.0.1 a'
print '     - this is experimental software and data! -'
print '                USE AT YOUR OWN RISK !'
print "==========================================================\n"

done = 0

print "Hello, this is:", server.identify()
print "Version:", server.version()
print "The following services are available:"
services = server.list_available_services()
for service in services:
	print service
print "\n\n"
print "-"*70
print "Server Introspection:"
print "-"*70
methods = server.system.listMethods()
print "Methods:"
for method in methods:
	if method[0:7]=='system.':
		continue
	print method
	print "\t", server.system.methodHelp(method)

